//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;
using MSHTML;
using System.Collections;
using System.ComponentModel;

namespace CSHttpUnit {
	public class CSWebRequest {
		public CSWebRequest() {
		}

		public void SetParameter(string ctlID, string content) {
			_controls.Add(ctlID);
			_names.Add(content);
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public string URL {
			set	{
				_url = value;
			}
			get {
				return _url;
			}
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public HTMLFormElementClass FORM {
			set {
				_form = value;
			}
			get {
				return _form;
			}
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public IHTMLElement BUTTON {
			set {
				_button = value;
			}
			get {
				return _button;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public MSHTML.IHTMLDocument2 HDOC {
			set {
				_hDoc = value;
			}
			get {
				return _hDoc;
			}
		}

		private string					_url				= null;
		private HTMLFormElementClass	_form				= null;
		private IHTMLElement			_button				= null;
		private MSHTML.IHTMLDocument2	_hDoc				= null;
		[EditorBrowsable(EditorBrowsableState.Never)]
		public ArrayList				_controls			= new ArrayList();
		[EditorBrowsable(EditorBrowsableState.Never)]
		public ArrayList				_names				= new ArrayList();
	}
}
