//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;
using System.Runtime.InteropServices;
using ExplorerLib;
using System.Threading;
using MSHTML;
using System.ComponentModel;

namespace CSHttpUnit {
	public class IEControl {
		public ExplorerLib.InternetExplorer explorer;
		public IWebBrowserApp webBrowser;     
		public MSHTML.IHTMLDocument2 hDoc = null;
		public Object doc = null;
		private bool docLoaded = false;

		public IEControl(){
		}

		public MSHTML.IHTMLDocument2 GetDocument(string sUrl) {
			_url = sUrl;
			explorer = new ExplorerLib.InternetExplorer();
			webBrowser = (IWebBrowserApp) explorer;
			explorer.DocumentComplete += new DWebBrowserEvents2_DocumentCompleteEventHandler(OnDocumentLoaded);
			Object arg1 = 0; Object arg2 = ""; Object arg3 = ""; Object arg4 = "";
			webBrowser.Navigate(sUrl, ref arg1, ref arg2, ref arg3, ref arg4);	
			while(!docLoaded) {}
			docLoaded = false;
			doc = explorer.Document;
			hDoc = (MSHTML.IHTMLDocument2)doc;
			return hDoc;
		}

		public MSHTML.IHTMLDocument2 GetDocument() {
			explorer = new ExplorerLib.InternetExplorer();
			webBrowser = (IWebBrowserApp) explorer;
			explorer.DocumentComplete += new DWebBrowserEvents2_DocumentCompleteEventHandler(OnDocumentLoaded);
			Object arg1 = 0; Object arg2 = ""; Object arg3 = ""; Object arg4 = "";
			webBrowser.Navigate(_url, ref arg1, ref arg2, ref arg3, ref arg4);	
			while(!docLoaded) {}
			docLoaded = false;
			doc = explorer.Document;
			hDoc = (MSHTML.IHTMLDocument2)doc;
			return hDoc;
		}

		public MSHTML.IHTMLDocument2 GetDocument(CSWebRequest request) {
			explorer = new ExplorerLib.InternetExplorer();
			webBrowser = (IWebBrowserApp) explorer;
			explorer.DocumentComplete += new DWebBrowserEvents2_DocumentCompleteEventHandler(OnDocumentLoaded);
			Object arg1 = 0; Object arg2 = ""; Object arg3 = ""; Object arg4 = "";
			
			webBrowser.Navigate(_url, ref arg1, ref arg2, ref arg3, ref arg4);
			
			while(!docLoaded) {}
			docLoaded = false;

			Object doc = explorer.Document;
			hDoc = (MSHTML.IHTMLDocument2)doc;
			
			HTMLFormElementClass form = hDoc.all.item(request.FORM.id, 0) as HTMLFormElementClass;
			this.FORM = form;

			this.FORM = SetParameter(request._controls[0].ToString(), request._names[0].ToString());
			this.FORM = SetParameter(request._controls[1].ToString(), request._names[1].ToString());			
			
			IHTMLElement b = this.FindElement(request.BUTTON.id);
			b.click();
			
			
			while(!docLoaded) {}
			docLoaded = false;

			doc = explorer.Document;				
			MSHTML.IHTMLDocument2 submitDoc = (MSHTML.IHTMLDocument2)doc;		
			return submitDoc;
		}
		
		private IHTMLElement FindElement(string buttonName) {
			IHTMLElementCollection ec = this.hDoc.all;
			foreach(IHTMLElement elem in ec) {
				if(elem.id == buttonName) {
					return elem;	
				}
			}
			return null;
		}

		public HTMLFormElementClass SetParameter(string ctlID, string content) {
			IHTMLInputElement input = (IHTMLInputElement)this.FORM.namedItem(ctlID);
			input.value = content;
			return this.FORM;
		}

		private void OnDocumentLoaded(Object ob1, ref Object URL) {
			docLoaded = true;
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public HTMLFormElementClass FORM {
			set {
				_form = value;
			}
			get {
				return _form;
			}
		}

		public static string				_url				= null;
		private static HTMLFormElementClass	_form				= null;
	}
}
