//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;

namespace CSHttpUnit {
	public class CSWebConversation {
		public CSWebConversation() {
		}
		
		public CSWebResponse GetResponse(string sUrl) {
			hDoc = ie.GetDocument(sUrl);
			response.TITLE = hDoc.title;			 
			response.HDOC = hDoc;
			return response;
		}

		public CSWebResponse GetResponse(CSWebRequest request) {
			hDoc = ie.GetDocument(request);
			response.TITLE = hDoc.title;
			response.HDOC = hDoc;
			return response;
		}

		private MSHTML.IHTMLDocument2	hDoc				= null;
		private IEControl				ie					= new IEControl();
		private CSWebTable				wt					= new CSWebTable();
		private CSWebResponse			response			= new CSWebResponse();

	}
}
