//Copyright (C) 2003  Thomas Schbel
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

using System;
using MSHTML;
using System.Collections;
using System.ComponentModel;

namespace CSHttpUnit {
	public class CSWebLink {
		public CSWebLink() {
		}
		
		[EditorBrowsable(EditorBrowsableState.Never)]
		public string ID {
			set	{
				_id = value;
			}
			get {
				return _id;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public HTMLAnchorElementClass LINK {
			set {
				_link = value;
			}
			get {
				return _link;
			}
		}
		
		[EditorBrowsable(EditorBrowsableState.Always)]
		public string URL {
			set	{
				_url = value;
			}
			get {
				return _url;
			}
		}

		private string					_url			= null;
		private string					_id				= null;
		private HTMLAnchorElementClass  _link			= null;
	}
}
